config/routes.rb
Rails.application.routes.draw do

  resources :tweets do
    resources :comments
  end
  resources :users
  root 'tweets#index'

end

app/models/comment.rb
class Comment < ActiveRecord::Base
  belongs_to :tweet #Proviene de la tabla tweet
end
















#COMENTAR EL CODIGO ES IMPORTANTE

app/models/tweet.rb
class Tweet < ActiveRecord::Base
  has_many :comments #referirse que tiene muchos comentarios
  belongs_to :user
end

app/models/user.rb
class User < ActiveRecord::Base
  has_many :tweets
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
    def new
        @Tweet= Tweet.find(params[:tweet_id])
        @comment= @Tweet.comments.new
    end

    def create
        @Tweet= Tweet.find(params[:tweet_id])
        comment=@Tweet.comments.new(comment_params)
        comment.save
        redirect_to tweet_path(@Tweet)
    end

    def destroy

      @tweet = Tweet.find(params[:tweet_id])
      @tweet.destroy
      redirect_to tweets_path

    end


    private

    def comment_params
        params.require(:comment).permit(:id,:content,:tweet_id)
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController

  def index
    @saludos="saludop"
  end
end

app/controllers/tweets_controller.rb
class TweetsController < ApplicationController

  def index
    @tweets = Tweet.all
  end
  def new
        @tweet = Tweet.new
  end
  def create
        @tweet= Tweet.new(tweet_params)
        @tweet.save
        redirect_to tweets_path
  end

  def edit

    @tweet = Tweet.find(params[:id])

  end

  def update

    @tweet = Tweet.find(params[:id])
    @tweet.update(tweet_params)
    redirect_to tweets_path

  end

  def destroy

    @tweet = Tweet.find(params[:id])
    @tweet.destroy
    redirect_to tweets_path

  end
  def show

    @tweet = Tweet.find(params[:id])
    @num = @tweet.user_id
    @user = User.find(@num)
    @comments = @tweet.comments.all

  end
  private
  def tweet_params
        params.require(:tweet).permit(:message, :tittle, :user_id)
  end


end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def index
    @users = User.all
  end
  def new
        @user = User.new
  end
  def create
        @user= User.new(user_params)
        @user.save
        redirect_to users_path
  end
   def edit
       @user = User.find(params[:id])
   end
   def update
       @user = User.find(params[:id])
       @user.update(user_params)
       redirect_to users_path
   end
   def show
     @user=User.find(params[:id])
     @tweets=@user.tweets.all
   end
   def destroy
        @user =  User.find(params[:id])
        @user.destroy
        redirect_to users_path
   end
   def user_params
        params.require(:user).permit(:name, :email )
   end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/tweets_helper.rb
module TweetsHelper
  
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/comments/new.html.erb
<%= form_for  [@Tweet, @comment] do |f| %>
<%=f.label :content %>
<%=f.text_field :content %>
<%=f.submit %>
<%end%>

app/views/home/index.html.erb
<h1>Hola maldijiiioooon</h1>
<p>
  <%= @saludos %>
</p>

app/views/layouts/_header.html.erb
<header class="navbar navbar-fixed-top navbar-inverse">
 <div class="container">
   <%= link_to "TWEETER", users_path, id: "logo" %>
   <nav>
     <ul class="nav navbar-nav navbar-right">
       <li><%= link_to "Home",   '#' %></li>
       <li><%= link_to "Help",   '#' %></li>
       <li><%= link_to "Log in", '#' %></li>
     </ul>
   </nav>
 </div>
</header>

app/views/layouts/_tweetForm.html.erb
<%= form_for @tweet do |t| %>
  <p>
      <%= t.label :tittle %><br>
      <%= t.text_field :tittle %><br>
      <%= t.label :message %><br>
      <%= t.text_field :message %><br><br>
      <%=t.collection_select :user_id, User.all, :id, :email%>

  </p>
  <p>
    <%= t.submit %>
  </p>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Blog</title>
  <%= render 'layouts/header' %>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>

app/views/tweets/edit.html.erb
<h1>Editar Tweets</h1>
<%= render 'layouts/tweetForm' %>

app/views/tweets/index.html.erb
<h1>List of tweets</h1>
		<center><%=link_to "New tweet", new_tweet_path%>
		<%=link_to "Users", users_path%> <br><br><br>

			<il>
				<% @tweets.each do |tweet| %>
						<%=link_to tweet.user.email, users_path(tweet.user.email) %><br>
						<li>
						<h3>Tittle</h3>
						<%= tweet.tittle %><br>
						<h3>Message</h3>
						<%= tweet.message %><br>
						<%=link_to "Details", tweet_path(tweet) %> <!--Las rutas están dada por las rutas de afueras en rake routes -->
						<%=link_to "Edit tweet", edit_tweet_path(tweet)%>
						<%= link_to "Delete", tweet, method: :delete, data: {confirm: "Are you sure?"} %>
						<h3>Comments</h3>
						<% @comments=tweet.comments.all%>
                        <% @comments.each do |comment|%>
                            <li>
                                <%=comment.content%>
                            </li>
                        <%end%>


					</li>
				<% end %>
			</il>

app/views/tweets/new.html.erb
<h1>Crear Tweets</h1>
<%= render 'layouts/tweetForm' %>

app/views/tweets/show.html.erb
<h1><%=@user.email %></h1>
<h2><%=@tweet.tittle %></h2>
<p><%=@tweet.message %></p>
<%=link_to "Return", tweets_path()%>
<%=link_to "Comments", new_tweet_comment_path(@tweet)%>
<ul>
    <% @comments.each do |comment|%>
        <li>
            <%=comment.content%>
        </li>
    <%end%>
</ul>

app/views/users/edit.html.erb
<h1>Edit information of user</h1>
<%= form_for @user do |t| %>
  <p>
      <%= t.label :email %><br>
      <%= t.text_field :email %>
  </p>
  <p>
    <%= t.submit %>

  </p>
<% end %>

app/views/users/index.html.erb
<h1>List of users</h1>
		<center><%=link_to "New user", new_user_path%>
    <%=link_to "New tweet", new_tweet_path%>
    <%=link_to "List Tweets", tweets_path%>


			<il>
				<% @users.each do |user| %>
					<li>
						<%= user.email %><br>
						<%=link_to "Edit user", edit_user_path(user)%>
						<%= link_to "Delete", user, method: :delete, data: {confirm: "Are you sure?"} %>
            <h2>Tweets</h2>
            <% @tweets=user.tweets.all%>
            <% @tweets.each do |tweet|%>
                <li>
                    <h3>Tittle</h3>
                    <%=tweet.tittle%><br>
                    <h3>Message</h3>
                    <%=tweet.message%><br>
                    <%=link_to "Edit tweet", edit_tweet_path(tweet)%>
                    <%= link_to "Delete", tweet, method: :delete, data: {confirm: "Are you sure?"} %>
                </li>
            <%end%>

            <br>

					</li>
				<% end %>
			</il>

app/views/users/new.html.erb
<h1>New User</h1>
<%= form_for @user do |t| %>
  <p>
      <%= t.label :email %><br>
      <%= t.text_field :email %>
  </p>
  <p>
    <%= t.submit %>
  </p>
<% end %>